#!/usr/bin/env sage

from sage.misc.banner import require_version
if not require_version(9, 7, print_message=True):
    exit(-1)

import ast

pkfile = sys.argv[1]

ls = open(pkfile).read().strip().split('\n')
poly = ast.literal_eval(ls[-1])
F.<a> = GF(2^(len(poly)-1), modulus=poly)
H = matrix(GF(2), [ast.literal_eval(l.replace(' ',',')) for l in ls[:-1]])

ls = [input(), input()]
g = F['x'](eval(ls[0].replace('^','**')))
L = eval(ls[1].replace('^','**'))

m = F.degree()
n = H.ncols()
t = H.nrows() // m

def mk(g,L):
    HH = matrix([alpha^i/g(alpha) for alpha in L] for i in range(t))
    H = block_matrix([[vector(list(el)).column() for el in row] for row in HH])
    return matrix(H.rows()).rref()

if H == mk(g, L):
    print('\x1b[32myes!\x1b[0m')
    exit()

print('\x1b[31mno??\x1b[0m')
exit(1)

