
#pragma once

template <typename T, typename = typename std::enable_if<std::is_arithmetic<T>::value,T>::type>
uint64_t myhash(T v)
{
    return v;
}
template <typename T, typename = typename std::enable_if<!std::is_arithmetic<T>::value,T>::type>
uint64_t myhash(T const &v)
{
    uint64_t r = 1 + v.size();
    for (auto x: v) {
        r *= 101;
        r += myhash(x);
    }
    return r;
}

template <typename T=void>
uint64_t myhash(uint64_t v, uint64_t w)
{
    return v ^ (w + 0x9e3779b9 + (v<<6) + (v>>2));
}

template <typename T>
struct myhashobj
{
    uint64_t operator()(T const &v) const { return myhash<T>(v); }
    bool operator()(T const &v, T const &w) const { return (*this)(v) < (*this)(w); }
};

