#!/bin/bash
set -euo pipefail

MAKE="make -j"

if [ -z "$1" ]; then
    echo $'\x1b[31mprovide claimed bit security level to break in argv[1]\x1b[0m' >&2
    exit 1
fi

sec="$1"
inf="../instances/pk_McEliece_$sec.txt"
outf="sol$sec.txt"

if [ ! -f $inf ]; then
    echo $'\x1b[31mchallenge file with claimed '"$sec"$' bits of security not found\x1b[0m' >&2
    exit 1
fi

ulimit -s 999999

$MAKE precompute
time ./precompute <"$inf" >generated.hpp
$MAKE main
time ./main >"$outf"

./check.sage "$inf" <"$outf" || (
    echo $'\x1b[31mresult was somehow wrong!?\x1b[0m' >&2
    exit 99
)

echo $'\x1b[32mchallenge with claimed '"$sec"$' bits of security solved!\x1b[0m' >&2

